<script setup lang="ts">
const fixBtn = {
  add: false,
  edit: true,
  delete: true
}

const tableHeaders = reactive([
  { title: '健保特約類別代號' },
  { title: '健保特約類別名稱' }
])

const tableData = reactive([
  {
    healthInsuranceCode: 'syscode01',
    healthInsuranceName: '教育部聯標'
  },
  {
    healthInsuranceCode: 'syscode01',
    healthInsuranceName: '教育部聯標'
  },
  {
    healthInsuranceCode: 'syscode01',
    healthInsuranceName: '教育部聯標'
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const onEdit = (val: any) => {
  console.log('parent edit', val)
}

const onDelete = (val: any) => {
  console.log('parent delete', val)
}

const turnPage = (val: any) => {
  pageObj.currentPage = val
}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">基本資料</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            健保特約類別
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">健保特約類別列表</h3>
          <div class="interact-button-list d-flex">
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>新增</p>
              <div class="icon-create"></div>
            </button>
          </div>
        </div>
      </div>
    </header>
    <div>
      <basic-table
        :fix-btn="fixBtn"
        :table-data="showData"
        :table-headers="tableHeaders"
        @delete="onDelete"
        @edit="onEdit"
      />
      <table-pagination
        :page-obj="pageObj"
        :total-page="totalPage"
        @turn-page="turnPage"
      />
    </div>
  </main>
</template>

<style lang="scss" scoped>
/** style */
</style>
